// Copyright (c) 2013 Vinay Bettadapura (Georgia Tech)

#ifndef _CORE_REG_EXP_GEN_TBB_
#define _CORE_REG_EXP_GEN_TBB_

#include <vector>
#include <string>
#include <set>

#include <tbb/parallel_for.h>
#include <tbb/blocked_range.h>

namespace core {

class RegExpGenTBB
{
public:
	RegExpGenTBB(
		std::vector<std::string>* random_reg_exps,
		const std::vector<std::string>* event_strings,
		std::set<std::string>* generated_regexps,
		const std::vector<double>* symbol_cdf,
		const std::vector<std::string>* all_symbols_unshuffled,
		std::vector<std::string> all_symbols,
		unsigned num
	)
	: v_random_reg_exps_(random_reg_exps),
	v_event_strings_(event_strings),
	s_generated_regexps_(generated_regexps),
	v_symbol_cdf_(symbol_cdf),
	v_all_symbols_unshuffled_(all_symbols_unshuffled),
	v_all_symbols_(all_symbols),
	num_symbols_(num) {}

	void operator() (const tbb::blocked_range<int>& r) const;

private:
	std::vector<std::string>* v_random_reg_exps_;
	const std::vector<std::string>* v_event_strings_;
	std::set<std::string>* s_generated_regexps_;
	const std::vector<double>* v_symbol_cdf_;
	const std::vector<std::string>* v_all_symbols_unshuffled_;
	std::vector<std::string> v_all_symbols_;
	unsigned num_symbols_;
};

}

#endif
