// Copyright (c) 2013 Vinay Bettadapura (Georgia Tech)

#ifndef _CORE_REG_EXP_GENERATOR_
#define _CORE_REG_EXP_GENERATOR_

#include <set>
#include <string>
#include <vector>

namespace core {

class RegExpGenerator
{
public:
	RegExpGenerator(
		std::vector<std::string> symbols,
		const std::vector<std::string>* symbols_unshuffled,
		const std::vector<double>* symbol_cdf,
		std::set<std::string>* generated_regexps,
		unsigned num
	);

	std::string Get();

private:
	std::string GetHelper();
	int GetRand(int min, int max);
	void GetSymbols(std::string& reg_ex, int num);
	double GetRandBetweenZeroAndOne();
	void GetProbSymbol(std::string& reg_ex);

	template<class bidiiter>
	bidiiter random_unique(bidiiter begin, bidiiter end, size_t num_random);

	std::vector<std::string> v_symbols_;
	const std::vector<std::string>* v_symbols_unshuffled_;
	const std::vector<double>* v_symbol_cdf_;
	std::set<std::string>* s_generated_regexps_;
	std::vector<std::string> v_special_chars_;
	unsigned N_;
};

}

#endif
