// Copyright (c) 2013 Vinay Bettadapura (Georgia Tech)

#include <boost/regex.hpp>
#include <iostream>
#include <string>
#include <vector>

#include "reg_exp_match_tbb.h"

using std::cout;
using std::string;
using std::vector;

namespace core {

void RegExpMatchTBB::operator() (const tbb::blocked_range<unsigned long>& r) const
{
	for(vector<string>::size_type i = r.begin(); i < r.end(); ++i)
	{
		for(vector<string>::size_type j = 0; j < v_random_reg_exps_->size(); ++j)
		{
			boost::regex reg_exp((*v_random_reg_exps_)[j]);

			if(boost::regex_match((*v_event_strings_)[i], reg_exp))
			{
				(*v_rand_regex_)[i].push_back((*v_random_reg_exps_)[j]);
			}
		}
	}
}

}
