// Copyright (c) 2013 Vinay Bettadapura (Georgia Tech)

#ifndef _CORE_REG_EXP_MATCH_TBB_
#define _CORE_REG_EXP_MATCH_TBB_

#include <tbb/blocked_range.h>
#include <tbb/parallel_for.h>

namespace core {

class RegExpMatchTBB
{
public:
	RegExpMatchTBB(
		const std::vector<std::string>* random_reg_exps,
		const std::vector<std::string>* event_strings,
		std::vector<std::vector<std::string> >* rand_regex
	)
	: v_random_reg_exps_(random_reg_exps),
	v_event_strings_(event_strings),
	v_rand_regex_(rand_regex) { }

	void operator() (const tbb::blocked_range<unsigned long>& r) const;

private:
	const std::vector<std::string>* v_random_reg_exps_;
	const std::vector<std::string>* v_event_strings_;
	std::vector<std::vector<std::string> >* v_rand_regex_;
};

}

#endif
