// Copyright (c) 2013 Vinay Bettadapura (Georgia Tech)

#ifndef _CORE_TF_DF_H_
#define _CORE_TF_DF_H_

#include <map>
#include <string>
#include <vector>

#include "abow_core.h"

namespace core {

class ABOWCore;

class TfDf
{
public:
	void reweight(std::vector<std::string>::size_type ti, ABOWCore* vc);

private:
	std::vector<std::string>::size_type track_index;
	ABOWCore* abow_core;

	void natural_no();
	void natural_idf();
	void natural_probidf();

	void log_no();
	void log_idf();
	void log_probidf();

	void augmented_no();
	void augmented_idf();
	void augmented_probidf();

	void boolean_no();
	void boolean_idf();
	void boolean_probidf();

	void logavg_no();
	void logavg_idf();
	void logavg_probidf();

	void regex_log_idf();
};

}

#endif
