// Copyright (c) 2013 Vinay Bettadapura (Georgia Tech)

#include <boost/foreach.hpp>
#include <boost/tokenizer.hpp>
#include <cmath>
#include <iostream>
#include <string>

#include "utils.h"

using std::string;
using std::vector;
using boost::tokenizer;
using boost::char_separator;

namespace core {

void tokenize(vector<string>& vOut, string& strIn, string strSep)
{
	strIn.erase(std::remove(strIn.begin(), strIn.end(), '\n'), strIn.end());
	strIn.erase(std::remove(strIn.begin(), strIn.end(), '\r'), strIn.end());

	char_separator<char> sep(strSep.c_str());
	tokenizer<char_separator<char> > tokens(strIn, sep);

	BOOST_FOREACH(string t, tokens)
	{
		vOut.push_back(t);
	}
}

double round(double d)
{
	return floor(d + 0.5);
}

string get_filename_from_path(string s)
{
	vector<string> v;
	string delimiter("/");
	tokenize(v, s, delimiter);
	return v[v.size() - 1];
}

string get_filename_without_extension_from_path(string s)
{
	s = get_filename_from_path(s);
	vector<string> v;
	string delimiter(".");
	tokenize(v, s, delimiter);
	return v[0];
}

}
